local ret = ... or {};

-- [ja] ステップゾーンアニメーションの処理回数
YA_NOTESKIN_FPS = 60;

-- [ja] 現在のビートを取得する（譜面で異なるものに対応）
function YA_NOTESKIN_GetPlayerSongBeat(player)
	local csteps;
	if player then
		csteps=GAMESTATE:GetCurrentSteps(player);
	else
		csteps=GAMESTATE:GetCurrentSteps(GAMESTATE:GetMasterPlayerNumber());
	end;
	if csteps then
		local timing=csteps:GetTimingData();
		return timing:GetBeatFromElapsedTime(GAMESTATE:GetSongPosition():GetMusicSeconds());
	else
		return 0;
	end;
end;

-- [ja] 現ステップゾーンアニメーション 
local cur_song;	-- [ja] 現在の楽曲
local chk_song;	-- [ja] 楽曲の切り替わりを取得するための一時記録 
function YA_NOTESKIN_UpdateReceptor(child,player)
	cur_song=GAMESTATE:GetCurrentSong();
	if cur_song and chk_song~=cur_song then
		global_begin = cur_song:GetFirstBeat()-8.0;
		chk_song=cur_song;
	end;
	local global_current=GAMESTATE:GetSongBeat();
	local player_current=YA_NOTESKIN_GetPlayerSongBeat(player);
	local beat=(player_current*10)%10;
	if global_current>=global_begin then
		if beat>=1 and beat<9 then
			child:setstate(1);
		else
			child:setstate(0);
		end;
	else
		child:setstate(2);
	end;
end;

ret.RedirTable =
{
	Up = "Up",
	Down = "Down",
	Left = "Left",
	Right = "Right",
	UpLeft = "UpLeft",
	UpRight = "UpRight",
};

local OldRedir = ret.Redir;
ret.Redir = function(sButton, sElement)
	sButton, sElement = OldRedir(sButton, sElement);

	--we want to use custom hold/roll per direction, but
	--keep global hold/roll heads and explosions.	
	if not string.find(sElement, "Head") and
	not string.find(sElement, "Explosion") then
		if string.find(sElement, "Hold") or
		string.find(sElement, "Roll") then
			return sButton, sElement;
		end
	end

	sButton = ret.RedirTable[sButton];

	return sButton, sElement;
end

local OldFunc = ret.Load;
function ret.Load()
	local t = OldFunc();

	--Explosion should not be rotated; it calls other actors.
	if Var "Element" == "Explosion"	then
		t.BaseRotationZ = nil;
	end
	return t;
end

ret.PartsToRotate =
{
	["Receptor"] = true,
	["Tap Explosion Bright"] = true,
	["Tap Explosion Dim"] = true,
	["Tap Note"] = true,
	["Tap Mine"] = false,
	["Tap Lift"] = true,
	["Tap Fake"] = true,
	["Tap Addition"] = true,
	["Hold Explosion"] = true,
	["Hold Head Active"] = true,
	["Hold Head Inactive"] = true,
	["Roll Explosion"] = true,
	["Roll Head Active"] = true,
	["Roll Head Inactive"] = true,
	["Hold LiftTail Active"] = true,
	["Hold LiftTail Inactive"] = true,
	["Roll LiftTail Active"] = true,
	["Roll LiftTail Inactive"] = true,
};
ret.Rotate =
{
	Up = 180,
	Down = 0,
	Left = 90,
	Right = -90,
	UpLeft = 0,
	UpRight = 0,
};

ret.Blank =
{
	["Hold Topcap Active"] = true,
	["Hold Topcap Inactive"] = true,
	["Roll Topcap Active"] = true,
	["Roll Topcap Inactive"] = true,
	["Hold Tail Active"] = true,
	["Hold Tail Inactive"] = true,
	["Roll Tail Active"] = true,
	["Roll Tail Inactive"] = true,
};

return ret;
